#ifndef bqtCaseValHH
#define bqtCaseValHH

#include "expr.hh"

class casevalue
{
	int token;
	exprp p0, p1;
	
	/* Tokens:
	 *    ELSE
	 *    '>' p0
	 *    '<' p0
	 *    '=' p0
	 *    LESSOREQUAL p0
	 *    GREATEROREQUAL p0
	 *    NOTEQUAL p0
	 *    p0 TO p1
	 */
public:
	casevalue(int tok) : token(tok) { }
	casevalue(int tok, exprp a) : token(tok), p0(a) { }
	casevalue(exprp a, exprp b) : token(TO), p0(a), p1(b) { }
};
class casevalues
{
	std::vector<casevalue> values;
public:
	casevalues(int tok)          { values.push_back(casevalue(tok)); }
	casevalues(int tok, exprp a) { values.push_back(casevalue(tok, a)); }
	casevalues(exprp a, exprp b) { values.push_back(casevalue(a, b)); }
	
	void set_as(casevalues *b)
	{
		values.insert(values.end(), b->values.begin(), b->values.end());
		delete b;
	}
};

#endif
